"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _chaynsApi = require("chayns-api");
var _standalone = require("prettier/standalone");
var _react = _interopRequireWildcard(require("react"));
var _reactSyntaxHighlighter = require("react-syntax-highlighter");
var _prism = require("react-syntax-highlighter/dist/esm/styles/prism");
var _codeHighlighter = require("../../types/codeHighlighter");
var _codeHighlighter2 = require("../../utils/codeHighlighter");
var _CodeHighlighter = require("./CodeHighlighter.styles");
var _CopyToClipboard = _interopRequireDefault(require("./copy-to-clipboard/CopyToClipboard"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
const CodeHighlighter = _ref => {
  let {
    theme = _codeHighlighter.CodeHighlighterTheme.Dark,
    code,
    copyButtonText,
    language,
    highlightedLines,
    shouldFormatCode = false,
    shouldShowLineNumbers = false
  } = _ref;
  const {
    browser
  } = (0, _chaynsApi.getDevice)();

  // function to style highlighted code
  const lineWrapper = (0, _react.useCallback)(lineNumber => {
    let style = {
      backgroundColor: 'none',
      display: 'block',
      borderRadius: '2px'
    };
    if (highlightedLines?.added && highlightedLines.added.includes(lineNumber)) {
      style = {
        ...style,
        backgroundColor: '#2EF29930'
      };
    } else if (highlightedLines?.removed && highlightedLines.removed.includes(lineNumber)) {
      style = {
        ...style,
        backgroundColor: '#F22E5B30'
      };
    } else if (highlightedLines?.marked && highlightedLines.marked.includes(lineNumber)) {
      style = {
        ...style,
        backgroundColor: '#cccccc40'
      };
    }
    return {
      style
    };
  }, [highlightedLines]);
  const formattedCode = (0, _react.useMemo)(() => {
    if (language) {
      const config = (0, _codeHighlighter2.getParserForLanguage)(language);
      if (shouldFormatCode && config) {
        return (0, _standalone.format)(code, config);
      }
      return code;
    }
    return code;
  }, [code, language, shouldFormatCode]);
  return (0, _react.useMemo)(() => /*#__PURE__*/_react.default.createElement(_CodeHighlighter.StyledCodeHighlighter, {
    browser: browser?.name,
    codeTheme: theme
  }, /*#__PURE__*/_react.default.createElement(_CodeHighlighter.StyledCodeHighlighterHeader, {
    codeTheme: theme
  }, /*#__PURE__*/_react.default.createElement(_CodeHighlighter.StyledCodeHighlighterFileName, {
    codeTheme: theme
  }, (0, _codeHighlighter2.formatLanguage)(language)), /*#__PURE__*/_react.default.createElement(_CopyToClipboard.default, {
    text: code,
    theme: theme,
    copyButtonText: copyButtonText
  })), /*#__PURE__*/_react.default.createElement(_reactSyntaxHighlighter.PrismAsyncLight, {
    language: language ?? '',
    showLineNumbers: shouldShowLineNumbers,
    style: theme === _codeHighlighter.CodeHighlighterTheme.Dark ? _prism.oneDark : _prism.oneLight,
    wrapLines: true,
    lineProps: lineWrapper
  }, formattedCode)), [browser?.name, theme, language, code, copyButtonText, shouldShowLineNumbers, lineWrapper, formattedCode]);
};
CodeHighlighter.displayName = 'CodeHighlighter';
var _default = exports.default = CodeHighlighter;
//# sourceMappingURL=CodeHighlighter.js.map